import ast, compiler

def assign(names, values):
  assert len(names)==len(values)

  for i in range(0,len(names)):
    ast.lookup(names[i].name)

  for i in range(0,len(names)-1):
    assert names[i].flags == "OP_ASSIGN" ## TODO
    ast.output("\t$P%d = new PerlInt" % (i+1))
    ast.output("\t$P%d = %s" % (i+1, ast.evaluate(values[i])))

  assert names[-1].flags == "OP_ASSIGN" ## TODO
  ast.output("\t%s = %s" % (names[-1].name, ast.evaluate(values[-1])))

  for i in range(len(names)-2,-1,-1):
    ast.output("\t%s = $P%d" % (names[i].name, i+1))

def process(node):
  if len(node.nodes)==1:

    if node.nodes[0].__class__ == compiler.ast.AssName:

      assign(node.nodes,[node.expr])

    elif node.nodes[0].__class__ == compiler.ast.AssList:
      assert node.expr.__class__ == compiler.ast.Tuple

      assign(node.nodes[0].nodes, node.expr.nodes)
      
    elif node.nodes[0].__class__ == compiler.ast.AssTuple:
      assert node.expr.__class__ == compiler.ast.Tuple

      assign(node.nodes[0].nodes, node.expr.nodes)
      
    else:
      print len(node.nodes)
      print node.nodes, node.expr
      ast.fail("Assign unimplemented")
  else:
    ast.fail("Assign unimplemented")
